Rating

React Bootstrap 5 Rating component

Responsive react star rating built with Bootstrap 5, React 18 and Material Design 2.0. Examples with stars or other custom symbols, styled active elements, dynamic icons and number of icons.

Rating component can be used to allow the users to share their opinion about the product, documentation page, photo and more.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can automatically initialize the rating component using MDBRating

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement title='Bad' itemId={1} icon='star' />
                <MDBRatingElement title='Poor' itemId={2} icon='star' />
                <MDBRatingElement title='OK' itemId={3} icon='star' />
                <MDBRatingElement title='Good' itemId={4} icon='star' />
                <MDBRatingElement title='Excellent' itemId={5} icon='star' />
              </MDBRating>
            );
          }
          
        
    

Controlled value

Create controlled component by passing value prop. Use a handler on onChange to update the state.

        
            
            import React, { useState } from 'react';
            import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';

            export default function App() {
              const [value, setValue] = useState(0);
              return (
                <MDBRating value={value} onChange={(val) => setValue(val)}>
                  <MDBRatingElement title='Bad' itemId={1} icon='star' />
                  <MDBRatingElement title='Poor' itemId={2} icon='star' />
                  <MDBRatingElement title='OK' itemId={3} icon='star' />
                  <MDBRatingElement title='Good' itemId={4} icon='star' />
                  <MDBRatingElement title='Excellent' itemId={5} icon='star' />
                </MDBRating>
              );
            }
          
        
    

Read only

If you want to use a rating to show the score you can only pass the active property.

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating defaultValue={3}>
                <MDBRatingElement itemId={1} icon='star' />
                <MDBRatingElement itemId={2} icon='star' />
                <MDBRatingElement itemId={3} icon='star' />
                <MDBRatingElement itemId={4} icon='star' />
                <MDBRatingElement itemId={5} icon='star' />
              </MDBRating>
            );
          }
          
        
    

Events

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {

            return (
              <MDBRating>
                <MDBRatingElement
                  itemId={1}
                  icon='star'
                  onClick={(e) => console.log(e)}
                  onMouseEnter={(e) => console.log(e)}
                />
                <MDBRatingElement
                  itemId={2}
                  icon='star'
                  onClick={(e) => console.log(e)}
                  onMouseEnter={(e) => console.log(e)}
                />
                <MDBRatingElement
                  itemId={3}
                  icon='star'
                  onClick={(e) => console.log(e)}
                  onMouseEnter={(e) => console.log(e)}
                />
                <MDBRatingElement
                  itemId={4}
                  icon='star'
                  onClick={(e) => console.log(e)}
                  onMouseEnter={(e) => console.log(e)}
                />
                <MDBRatingElement
                  itemId={5}
                  icon='star'
                  onClick={(e) => console.log(e)}
                  onMouseEnter={(e) => console.log(e)}
                />
              </MDBRating>
            );
          }
                 
        
    

Custom text

You can add extra text before or after the icon using insertAfter and insertBefore

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement className='px-2 d-flex' itemId={1} icon='star' insertBefore='1' insertAfter='1' />
                <MDBRatingElement className='px-2 d-flex' itemId={2} icon='star' insertBefore='2' insertAfter='2' />
                <MDBRatingElement className='px-2 d-flex' itemId={3} icon='star' insertBefore='3' insertAfter='3' />
                <MDBRatingElement className='px-2 d-flex' itemId={4} icon='star' insertBefore='4' insertAfter='4' />
                <MDBRatingElement className='px-2 d-flex' itemId={5} icon='star' insertBefore='5' insertAfter='5' />
              </MDBRating>
            );
          }
                 
        
    

Custom icons

You can use other icons easily using icon property.

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement itemId={1} icon='heart' />
                <MDBRatingElement itemId={2} icon='heart' />
                <MDBRatingElement itemId={3} icon='heart' />
                <MDBRatingElement itemId={4} icon='heart' />
                <MDBRatingElement itemId={5} icon='heart' />
              </MDBRating>
            );
          }
                 
        
    

Number of icons

If you want to display more or less icons in your rating, all you have to do is add as many rating elements like inside the MDBRating tag.

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement itemId={1} icon='star' />
                <MDBRatingElement itemId={2} icon='star' />
                <MDBRatingElement itemId={3} icon='star' />
                <MDBRatingElement itemId={4} icon='star' />
                <MDBRatingElement itemId={5} icon='star' />
                <MDBRatingElement itemId={6} icon='star' />
                <MDBRatingElement itemId={7} icon='star' />
                <MDBRatingElement itemId={8} icon='star' />
                <MDBRatingElement itemId={9} icon='star' />
                <MDBRatingElement itemId={10} icon='star' />
              </MDBRating>
            );
          }
                 
        
    

Icons custom color

If you want to set your own icon color you can use the color property

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement itemId={1} icon='star' color='#673ab7' />
                <MDBRatingElement itemId={2} icon='star' color='#3f51b5' />
                <MDBRatingElement itemId={3} icon='star' color='#2196f3' />
                <MDBRatingElement itemId={4} icon='star' color='#03a9f4' />
                <MDBRatingElement itemId={5} icon='star' color='#00bcd4' />
              </MDBRating>
            );
          }
                 
        
    

Dynamic icons

You can make you rating more dynamically by adding dynamic

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating dynamic>
                <MDBRatingElement size='lg' itemId={1} icon='angry' color='#673ab7' />
                <MDBRatingElement size='lg' itemId={2} icon='frown' color='#3f51b5' />
                <MDBRatingElement size='lg' itemId={3} icon='meh' color='#2196f3' />
                <MDBRatingElement size='lg' itemId={4} icon='smile' color='#03a9f4' />
                <MDBRatingElement size='lg' itemId={5} icon='grin-stars' color='#00bcd4' />
              </MDBRating>
            );
          }
                 
        
    

Styling active elements

You can use active class to set different styles for selected elements

        
            
            import React from 'react';
            import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
            
            export default function App() {

              return (
                <MDBRating className='rating-active-example'>
                  <MDBRatingElement itemId={1} icon='star' />
                  <MDBRatingElement itemId={2} icon='star' />
                  <MDBRatingElement itemId={3} icon='star' />
                  <MDBRatingElement itemId={4} icon='star' />
                  <MDBRatingElement itemId={5} icon='star' />
                </MDBRating>
              );
            }
          
        
    
        
            
            .rating-active-example .active {
              color: #00c851 !important;
            }
          
        
    

Popover implementation example

Rating allows you to easily add popover functionality

        
            
          import React from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            return (
              <MDBRating>
                <MDBRatingElement popover='Example text' itemId={1} icon='star' />
                <MDBRatingElement popover='Example text' itemId={2} icon='star' />
                <MDBRatingElement popover='Example text' itemId={3} icon='star' />
                <MDBRatingElement popover='Example text' itemId={4} icon='star' />
                <MDBRatingElement popover='Example text' itemId={5} icon='star' />
              </MDBRating>
            );
          }
                 
        
    

Get selected value

Get the value selected by the user. Open the browser console to test how it's work

        
            
          import React, { useState, useEffect } from 'react';
          import { MDBRating, MDBRatingElement } from 'mdb-react-ui-kit';
          
          export default function App() {
            const [selectValue, setSelectValue] = useState(0);

            useEffect(() => {
              console.log(selectValue);
            }, [selectValue]);

            return (
              <MDBRating onChange={(value) => setSelectValue(value)} >
                <MDBRatingElement itemId={1} icon='star' />
                <MDBRatingElement itemId={2} icon='star' />
                <MDBRatingElement itemId={3} icon='star' />
                <MDBRatingElement itemId={4} icon='star' />
                <MDBRatingElement itemId={5} icon='star' />
              </MDBRating>
            );
          }
                 
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Rating - API


Import

        
            
        import { 
          MDBRating,
          MDBRatingElement
        } from 'mdb-react-ui-kit';
      
        
    

Properties

MDBRating

Name Type Default Description Example
defaultValue number - The default value. Use when the component is not controlled <MDBRating defaultValue={4} />
value number - The value of the rating <MDBRating value={4} />
dynamic Boolean false Dynamically change previous icons to the currently selected/hovered icon <MDBRating dynamic />
readonly boolean false Disable hover, click and keypress events. <MDBRating readonly />
style React.CSSProperties - Add custom styles to MDBRating element. <MDBRating style={customStyles} />

MDBRatingElement

Name Type Default Description Example
color string '' Set icon color (for use only on the icons element) <MDBRatingElement color="#3f51b5" />
itemId Number - Sets element id number <MDBRatingElement itemId={1} />
icon string - Defines rating element icon <MDBRatingElement icon="star" />
iconClassName string '' Add custom classes to MDBRatingElement icon element <MDBRatingElement iconClassName={iconClasses} />
insertAfter React.ReactNode - Set a custom text after the icon <MDBRatingElement color="#3f51b5" insertAfter='1' />
insertBefore React.ReactNode - Set a custom text before the icon <MDBRatingElement color="#3f51b5" insertBefore='1' />
popover React.ReactNode - Set the text displayed in the popover (for use only on the icons element) <MDBRatingElement popover="exampleTitle" />
size 'sm' | 'lg' 'sm' Defines the icon size <MDBRatingElement size="lg" />

Events

MDBRating

Name Type Description
onChange (value: number) => void Fires immediately when the MDBRating component changes.

CSS variables

As part of MDB’s evolving CSS variables approach, rating now use local CSS variables on .rating for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
        // .rating
        --#{$prefix}rating-icon-padding: #{$rating-icon-padding};
        
        
    

SCSS variables

        
            
        $rating-icon-padding: 0.25rem;

Rating

Vue Bootstrap 5 Star Rating component

Responsive star rating built with the latest Bootstrap 5 and Vue 3. Rating provides insight into others opinions and experiences with a product. Use stars or other custom symbols (i.e. smiling faces}

Rating component can be used to allow the users to share their opinion about the product, documentation page, photo and more.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can create the rating component using MDBRating and MDBRatingItem

        
            
            <template>
              <MDBRating v-model="basicActive">
                <MDBRatingItem title="Bad" :index="1" />
                <MDBRatingItem title="Poor" :index="2" />
                <MDBRatingItem title="OK" :index="3" />
                <MDBRatingItem title="Good" :index="4" />
                <MDBRatingItem title="Excellent" :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const basicActive = ref(0);
        
                  return {
                    basicActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const basicActive = ref(0);
            </script>
          
        
    

Read only

If you want to use a rating to show the score you can use the readonly property

        
            
            <template>
              <MDBRating v-model="readonlyActive" readonly :value="3">
                <MDBRatingItem :index="1" />
                <MDBRatingItem :index="2" />
                <MDBRatingItem :index="3" />
                <MDBRatingItem :index="4" />
                <MDBRatingItem :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const readonlyActive = ref(3);
        
                  return {
                    readonlyActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const readonlyActive = ref(3);
            </script>
          
        
    

Events

Rating emits events after click and hover element. Check the browser console to test it.

        
            
            <template>
              <MDBRating v-model="eventsActive" events @itemClick="itemClick" @itemHover="itemHover">
                <MDBRatingItem :index="1" />
                <MDBRatingItem :index="2" />
                <MDBRatingItem :index="3" />
                <MDBRatingItem :index="4" />
                <MDBRatingItem :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const itemClick = e => {
                    console.log(e);
                  };
                  const itemHover = e => {
                    console.log(e);
                  };
                  const eventsActive = ref(0);
        
                  return {
                    itemClick,
                    itemHover,
                    eventsActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const itemClick = (e: MouseEvent) => {
                console.log(e);
              };
              const itemHover = (e: MouseEvent) => {
                console.log(e);
              };
              const eventsActive = ref(0);
            </script>
          
        
    

Custom text

You can add extra text before or after the icon using dinsertBefore and insertAfter

        
            
            <template>
              <MDBRating v-model="customActive">
                <MDBRatingItem :index="1" insertBefore="1" insertAfter="1"/>
                <MDBRatingItem :index="2" insertBefore="2" insertAfter="2"/>
                <MDBRatingItem :index="3" insertBefore="3" insertAfter="3"/>
                <MDBRatingItem :index="4" insertBefore="4" insertAfter="4"/>
                <MDBRatingItem :index="5" insertBefore="5" insertAfter="5"/>
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const customActive = ref(0);
        
                  return {
                    customActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const customActive = ref(0);
            </script>
          
        
    

Custom icons

You can use other icons easily with icon property

        
            
            <template>
              <MDBRating v-model="iconActive">
                <MDBRatingItem icon="heart" :index="1" />
                <MDBRatingItem icon="heart" :index="2" />
                <MDBRatingItem icon="heart" :index="3" />
                <MDBRatingItem icon="heart" :index="4" />
                <MDBRatingItem icon="heart" :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const iconActive = ref(0);
        
                  return {
                    iconActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const iconActive = ref(0);
            </script>
          
        
    

Number of icons

If you want to display more or less icons in your rating, all you have to do is add as many MDBRatingItems as you like

        
            
            <template>
              <MDBRating v-model="iconNumberActive">
                <MDBRatingItem :index="1" />
                <MDBRatingItem :index="2" />
                <MDBRatingItem :index="3" />
                <MDBRatingItem :index="4" />
                <MDBRatingItem :index="5" />
                <MDBRatingItem :index="6" />
                <MDBRatingItem :index="7" />
                <MDBRatingItem :index="8" />
                <MDBRatingItem :index="9" />
                <MDBRatingItem :index="10" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const iconNumberActive = ref(0);
                  return {
                    iconNumberActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const iconNumberActive = ref(0);
            </script>
          
        
    

Icons custom color

If you want to set your own icon color you can use the color property

        
            
            <template>
              <MDBRating v-model="iconsColorActive">
                <MDBRatingItem :index="1" color="#673ab7" />
                <MDBRatingItem :index="2" color="#3f51b5" />
                <MDBRatingItem :index="3" color="#2196f3" />
                <MDBRatingItem :index="4" color="#03a9f4" />
                <MDBRatingItem :index="5" color="#00bcd4" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const iconsColorActive = ref(0);
                  return {
                    iconsColorActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const iconsColorActive = ref(0);
            </script>
          
        
    

Dynamic icons

You can make you rating more dynamically by adding dynamic property

        
            
            <template>
              <MDBRating v-model="dynamicActive" dynamic>
                <MDBRatingItem icon="angry" size="lg" :index="1" color="#673ab7" />
                <MDBRatingItem icon="frown" size="lg" :index="2" color="#3f51b5" />
                <MDBRatingItem icon="meh" size="lg" :index="3" color="#2196f3" />
                <MDBRatingItem icon="smile" size="lg" :index="4" color="#03a9f4" />
                <MDBRatingItem icon="grin-stars" size="lg" :index="5" color="#00bcd4"/>
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const dynamicActive = ref(0);
                  return {
                    dynamicActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const dynamicActive = ref(0);
            </script>
          
        
    

Styling active elements

You can use active class to set different styles for selected elements

        
            
            <template>
              <MDBRating v-model="stylingActive">
                <MDBRatingItem :index="1" />
                <MDBRatingItem :index="2" />
                <MDBRatingItem :index="3" />
                <MDBRatingItem :index="4" />
                <MDBRatingItem :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
          <script>
            import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
            import { ref } from "vue";
            export default {
              components: {
                MDBRating,
                MDBRatingItem
              },
              setup() {
                const stylingActive = ref(0);
                return {
                  stylingActive
                }
              }
            };
            </script>
          
        
    
        
            
          <script setup lang="ts">
            import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
            import { ref } from "vue";

            const stylingActive = ref(0);
          </script>
          
        
    
        
            
            <style>
              .active {
                color: #00c851;
              }
            </style>
          
        
    

Popover implementation example

Rating allows you to easily add popover functionality

        
            
            <template>
              <MDBRating v-model="popoverActive">
                <MDBRatingItem :index="1" popover="Example text" />
                <MDBRatingItem :index="2" popover="Example text" />
                <MDBRatingItem :index="3" popover="Example text" />
                <MDBRatingItem :index="4" popover="Example text" />
                <MDBRatingItem :index="5" popover="Example text" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const popoverActive = ref(0);
                  return {
                    popoverActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const popoverActive = ref(0);
            </script>
          
        
    

Get selected value

To get the value selected just use v-model value

        
            
            <template>
              <MDBRating v-model="selectedActive">
                <MDBRatingItem :index="1" />
                <MDBRatingItem :index="2" />
                <MDBRatingItem :index="3" />
                <MDBRatingItem :index="4" />
                <MDBRatingItem :index="5" />
              </MDBRating>
            </template>
          
        
    
        
            
            <script>
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";
              export default {
                components: {
                  MDBRating,
                  MDBRatingItem
                },
                setup() {
                  const selectedActive = ref(0);
                  return {
                    selectedActive
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const selectedActive = ref(0);
            </script>
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Rating - API


Import

        
            
          <script>
            import { 
              MDBRating, 
              MDBRatingItem 
            } from "mdb-vue-ui-kit";
          </script>
        
        
    

Properties

Rating

Name Type Default Description
tag String 'ul' Defines tag of the MDBRating element
v-model String Indicates rating value
readonly Boolean false Disable hover, click and keypress events
events Boolean false Enable emitting click and hover events on rating elements
dynamic Boolean false Dynamically change previous icons to the currently selected/hovered icon
classes String '' Adds custom classes to MDBRating element

Rating Item

Name Type Default Description
tag String 'li' Defines tag of the MDBRatingItem element
classes String Adds custom classes to MDBRatingItem element
iconClass String Adds custom classes to icon element
icon String 'star' Defines rating icon
flag String '' Enables using flags as icon
size String 'sm' Defines icon size
color String 'sm' Defines icon color
title String '' Set the text displayed in the tooltip
index Number Set index on rating element (obligatory property)
popover Boolean | String false Enables showing popover on click. When true enables using #default slot as popover content. When String, passed text is used as popover content
insertBefore String '' Set a custom text before the icon
insertAfter String '' Set a custom text after the icon

Events

Events below have to be used together with events prop.

Name Description
itemClick This event fires immediately when you clicked on icon. The clicked element is available as the target property of the event.
itemHover This event fires immediately when you hovered on icon. The hovered element is available as the target property of the event.
        
            
        <template>
          <MDBRating
            v-model="eventsActive"
            events
            @itemClick="itemClick"
            @itemHover="itemHover"
          >
            <MDBRatingItem :index="1" />
            <MDBRatingItem :index="2" />
            <MDBRatingItem :index="3" />
            <MDBRatingItem :index="4" />
            <MDBRatingItem :index="5" />
          </MDBRating>
        </template>
        
        
    
        
            
        <script>
          import { MDBRating, MDBRatingItem} from "mdb-vue-ui-kit";
          import { ref } from "vue";
          export default {
            components: {
              MDBRating,
              MDBRatingItem
            },
            setup() {
              const itemClick = e => {
                console.log(e);
              };
              const itemHover = e => {
                console.log(e);
              };
              const eventsActive = ref(0);
        
              return {
                itemClick,
                itemHover,
                eventsActive
              }
            }
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBRating, MDBRatingItem } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          
          const itemClick = (e: MouseEvent) => {
            console.log(e);
          };
          const itemHover = (e: MouseEvent) => {
            console.log(e);
          };
          const eventsActive = ref(0);
          </script>
        
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, rating now use local CSS variables on .rating for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
        // .rating
        --#{$prefix}rating-icon-padding: #{$rating-icon-padding};
        
        
    

SCSS variables

        
            
        $rating-icon-padding: 0.25rem;

Rating

Angular Bootstrap 5 Star Rating component

Responsive star rating built with Bootstrap 5, Angular and Material Design. Rating provides insight into others opinions and experiences with a product. Use stars or other custom symbols (i.e. smiling faces}

Rating component can be used to allow the users to share their opinion about the product, documentation page, photo and more.

Note: Read the API tab to find all available options and advanced customization


Basic example

        
            
            <mdb-rating>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Read only

If you want to use a rating to show the score you can use the readonly input

        
            
            <mdb-rating [readonly]="true">
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Events

Rating emits events after click and hover element. Check the browser console to test it.

        
            
            <mdb-rating (onHover)="log($event)" (onSelect)="log($event)">
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              constructor() {}

              log(event: any): void {
                console.log(event);
              }
            }
          
        
    

Custom text

You can add extra text before or after the icon using after and before input

        
            
            <mdb-rating>
              <mdb-rating-icon [after]="'1'" [before]="'1'" class="text-primary px-2"></mdb-rating-icon>
              <mdb-rating-icon [after]="'2'" [before]="'2'" class="text-primary px-2"></mdb-rating-icon>
              <mdb-rating-icon [after]="'3'" [before]="'3'" class="text-primary px-2"></mdb-rating-icon>
              <mdb-rating-icon [after]="'4'" [before]="'4'" class="text-primary px-2"></mdb-rating-icon>
              <mdb-rating-icon [after]="'5'" [before]="'5'" class="text-primary px-2"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Custom icons

You can use other icons easily. Just use icon input.

        
            
            <mdb-rating>
              <mdb-rating-icon [icon]="'far fa-heart fa-sm text-primary'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-heart fa-sm text-primary'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-heart fa-sm text-primary'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-heart fa-sm text-primary'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-heart fa-sm text-primary'"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Number of icons

If you want to display more or less icons in your rating, all you have to do is add as many icons as you like inside the mdb-rating.

        
            
            <mdb-rating>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Icons custom color

If you want to set your own icon color you can use the color input

        
            
            <mdb-rating>
              <mdb-rating-icon [color]="'#673ab7'"></mdb-rating-icon>
              <mdb-rating-icon [color]="'#3f51b5'"></mdb-rating-icon>
              <mdb-rating-icon [color]="'#2196f3'"></mdb-rating-icon>
              <mdb-rating-icon [color]="'#03a9f4'"></mdb-rating-icon>
              <mdb-rating-icon [color]="'#00bcd4'"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Dynamic icons

You can make you rating more dynamically by adding different icons

        
            
            <mdb-rating>
              <mdb-rating-icon [icon]="'far fa-angry fa-lg'" [color]="'#673ab7'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-frown fa-lg'" [color]="'#3f51b5'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-meh fa-lg'" [color]="'#2196f3'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-smile fa-lg'" [color]="'#03a9f4'"></mdb-rating-icon>
              <mdb-rating-icon [icon]="'far fa-grin-stars fa-lg'" [color]="'#00bcd4'"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Styling active elements

You can use active class to set different styles for selected elements

        
            
            <mdb-rating>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    
        
            
            .active {
              color: #00c851;
            }
          
        
    

Popover implementation example

Rating allows you to easily add popover functionality

        
            
            <mdb-rating>
              <mdb-rating-icon class="text-primary" mdbPopover="example text"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary" mdbPopover="example text"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary" mdbPopover="example text"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary" mdbPopover="example text"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary" mdbPopover="example text"></mdb-rating-icon>
            </mdb-rating>
          
        
    

Get selected value

To get the value selected by the user just listen for the onSelect.mdb.rating event that returns a value. Open the browser console to test how it's work

        
            
            <mdb-rating (onHover)="log($event)" (onSelect)="log($event)">
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>
          
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              constructor() {}

              log(event: any): void {
                console.log(event);
              }
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Rating - API


Import

        
            
          import { MdbRatingModule } from 'mdb-angular-ui-kit/rating';
          …
          @NgModule ({
            ...
            imports: [MdbRatingModule],
            ...
          })
        
        
    

Inputs

Name Type Default Description
readonly Boolean false Disable hover, click and keypress events
after String '' Set a custom text after the icon
before String '' et a custom text before the icon
color String '' Set icon color (for use only on the icons element)

Outputs

Name Type Description
onSelect EventEmitter<number> This output fires immediately when you clicked on icon.
onHover EventEmitter<number> This output fires immediately when you hovered on icon.
        
            
            <mdb-rating (onSelect)="onSelect($event)">
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
              <mdb-rating-icon class="text-primary"></mdb-rating-icon>
            </mdb-rating>                               
            
        
    
        
            
            import { Component } from '@angular/core';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              onSelect(event: number): void {
                console.log('rating selected: ', event);
              }
            }                            
            
        
    

CSS variables

As part of MDB’s evolving CSS variables approach, rating now use local CSS variables on .rating for enhanced real-time customization. Values for the CSS variables are set via Sass, so Sass customization is still supported, too.

        
            
        // .rating
        --#{$prefix}rating-icon-padding: #{$rating-icon-padding};
        
        
    

SCSS variables

        
            
        $rating-icon-padding: 0.25rem;